package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.RespDTO;
import com.diagbot.dto.SysMenuPermissionDTO;
import com.diagbot.dto.SysRoleDTO;
import com.diagbot.dto.SysRoleMenuDTO;
import com.diagbot.entity.SysRole;
import com.diagbot.entity.wrapper.SysMenuWrapper;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.SysRoleServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.vo.SysRoleMenuQueryVO;
import com.diagbot.vo.SysRoleMenuSaveVO;
import com.diagbot.vo.SysRoleQueryVO;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: gaodm
 * @time: 2020/4/27 10:13
 */
@Component
public class SysRoleFacade extends SysRoleServiceImpl {

    public List<SysRoleDTO> page(SysRoleQueryVO sysRoleQueryVO) {
        List<SysRole> sysRoleList = this.list(new QueryWrapper<SysRole>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .gt("id", -1L)
        );
        List<SysRoleDTO> sysRoleDTOList = BeanUtil.listCopyTo(sysRoleList, SysRoleDTO.class);
        return sysRoleDTOList;
    }

//    public SysRoleMenuDTO getRoleMenu(SysRoleMenuQueryVO sysRoleMenuQueryVO) {
//        List<SysMenuPermissionDTO> sysMenuPermissionDTOList = this.getMenuPermission(sysRoleMenuQueryVO);
//        Map<Long, List<SysMenuPermissionDTO>> menuMap = EntityUtil.makeEntityListMap(sysMenuPermissionDTOList, "menuId");
//        List<SysMenuPermissionDTO> menuRes = menuMap.get(-1L);
//        for (SysMenuPermissionDTO bean : menuRes) {
//            getSonMenu(bean, menuMap);
//        }
//        return null;
//    }
//
//    /**
//     * 递归获取菜单结构
//     *
//     * @param menu    当前菜单
//     * @param menuMap 菜单集
//     * @return 菜单结构
//     */
//    public List<SysRoleMenuDTO> getSonMenu(SysMenuPermissionDTO menu, Map<Long, List<SysMenuPermissionDTO>> menuMap) {
//        List<SysMenuPermissionDTO> res = new ArrayList<>();
//        List<SysMenuPermissionDTO> list = menuMap.get(menu.getMenuId());
//        if (ListUtil.isNotEmpty(list)) {
//            List
//            menu.set(list);
//            for (SysMenuWrapper bean : list) {
//                getSonMenu(bean, menuMap);
//            }
//        }
//        return res;
//    }

    public Boolean saveRoleMenu(SysRoleMenuSaveVO sysRoleMenuSaveVO) {
        return null;
    }
}
